// MFCDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MFC.h"
#include "MFCDlg.h"

namespace NetSend
{
#include "netsend.h"
}

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CMFCDlg dialog




CMFCDlg::CMFCDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMFCDlg::IDD, pParent)
	, m_To(_T(""))
	, m_Text(_T(""))
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMFCDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_TO, m_To);
	DDV_MaxChars(pDX, m_To, 255);
	DDX_Text(pDX, IDC_TEXT, m_Text);
	DDV_MaxChars(pDX, m_Text, 127);
	DDX_Control(pDX, IDC_LIST1, m_Replies);
}

BEGIN_MESSAGE_MAP(CMFCDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_SEND, &CMFCDlg::OnBnClickedSend)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDOK, &CMFCDlg::OnBnClickedSend)
END_MESSAGE_MAP()


// CMFCDlg message handlers

BOOL CMFCDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	InitCommonControls();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// Create interface
	LPCSTR lpszResult = NetSend::Create(0);
	// 0 - Fomine Net Send GUI
	// 1 - Winpopup LAN Messenger

	if(lpszResult != 0) {
		::AfxMessageBox(lpszResult);
		return FALSE;
	}

	CRect rect;
	m_Replies.GetClientRect(&rect);
	rect.right -= ::GetSystemMetrics(SM_CXVSCROLL);
	m_Replies.InsertColumn(0, _T("To"), LVCFMT_LEFT, rect.Width()/5*2);
	m_Replies.InsertColumn(1, _T("Reply"), LVCFMT_LEFT, rect.Width()-rect.Width()/5*2);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMFCDlg::OnDestroy()
{
	CDialog::OnDestroy();

	NetSend::Destroy();
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMFCDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);
 
		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMFCDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CMFCDlg::OnBnClickedSend()
{
	m_Replies.DeleteAllItems();

	UpdateData();

	LPCSTR lpszResult = NetSend::Send(m_To, m_Text);

	if(lpszResult != 0) {
		::AfxMessageBox(lpszResult);
	}
	else {
		CHAR szTo[256];
		CHAR szReply[512];
		while(NetSend::GetNextReply(szTo, sizeof(szTo), szReply, sizeof(szReply))) {
			m_Replies.InsertItem(m_Replies.GetItemCount(), szTo);
			m_Replies.SetItemText(m_Replies.GetItemCount()-1, 1, szReply);
		}
	}
}
