using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;


namespace NET.CS
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            string result = NetSend.Create(0);
            // 0 - Fomine Net Send GUI
            // 1 - Winpopup LAN Messenger

            if (result != null)
            {
                MessageBox.Show(result, "error");
                Close();
            }
        }


        private void btnSend_Click(object sender, EventArgs e)
        {
            replies.Items.Clear();

            string result = NetSend.Send(to.Text, text.Text);

            if (result != null)
            {
                MessageBox.Show(result, "error");
            }
            else
            {
                StringBuilder to1 = new StringBuilder(512);
                StringBuilder reply1 = new StringBuilder(512);
                while (NetSend.GetNextReply(to1, to1.Capacity, reply1, reply1.Capacity) != 0)
                {
                    replies.Items.Add(to1.ToString()).SubItems.Add(reply1.ToString());
                }
            }
        }

        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            NetSend.Destroy();
        }
    }

    public class NetSend
    {
        [DllImport("netsend.dll")]
        [return: MarshalAs(UnmanagedType.LPStr)]
        public static extern String Create(Int32 nMessenger);
        [DllImport("netsend.dll")]
        public static extern void Destroy();
        [DllImport("netsend.dll", CharSet = CharSet.Ansi, ExactSpelling = true)]
        [return: MarshalAs(UnmanagedType.LPStr)]
        public static extern String Send([In, MarshalAs(UnmanagedType.LPStr)] String lpszTo, [In, MarshalAs(UnmanagedType.LPStr)] String lpszText);
        [DllImport("netsend.dll")]
        public static extern UInt32 GetNextReply([MarshalAs(UnmanagedType.LPStr)] StringBuilder to, int maxToCount, [MarshalAs(UnmanagedType.LPStr)] StringBuilder reply, int maxReplyCount);
    }
}